NX Open C++ Reference Guide
Public Types | Public Member Functions | List of all members
NXOpen::Features::ProjectCurveBuilder Class Reference

Represents a NXOpen::Features::ProjectCurve builder. More...

Inheritance diagram for NXOpen::Features::ProjectCurveBuilder:
NXOpen::Features::FeatureBuilder NXOpen::Builder NXOpen::TaggedObject NXOpen::GeometricUtilities::IComponentBuilder

Public Types

enum  ArcLengthType {
  ArcLengthTypeBothXY, ArcLengthTypeFirstXThenY, ArcLengthTypeFirstYThenX, ArcLengthTypeXOnly,
  ArcLengthTypeYOnly
}
 Represents Equal Arc Length type. More...
 
enum  DirectionType {
  DirectionTypeAlongFaceNormal, DirectionTypeTowardPoint, DirectionTypeTowardLine, DirectionTypeAlongVector,
  DirectionTypeAngleToVector
}
 Represents direction method. More...
 
enum  ProjectionOptionType { ProjectionOptionTypeNone, ProjectionOptionTypeProjectBothSides, ProjectionOptionTypeEqualArcLength }
 Represents projection option type used when direction type is along vector. More...
 

Public Member Functions

NXOpen::ExpressionAngleToProjectionVector ()
 Returns the angle to projection vector
Created in NX5.0.0. More...
 
double BridgedGapSize ()
 Returns the maximum bridged gap size. More...
 
NXOpen::GeometricUtilities::CurveFitDataCurveFitData ()
 Returns the curve fit settings
Created in NX8.0.0. More...
 
NXOpen::GeometricUtilities::CurveFitJoinCurveFitJoinData ()
 Returns the curve fit join method
More...
 
NXOpen::Features::ProjectCurveBuilder::ArcLengthType EqualArcLengthMethod ()
 Returns the equal arc length method
Created in NX5.0.0. More...
 
NXOpen::SelectObjectListFaceToProjectTo ()
 Returns the face to project to
Created in NX5.0.0. More...
 
bool GapOption ()
 Returns the gap option whether to create curve to bridge gap or not
Created in NX7.5.0. More...
 
NXOpen::GeometricUtilities::CurveOptionsInputCurvesOption ()
 Returns the input curves option
Created in NX5.0.0. More...
 
NXOpen::SelectDisplayableObjectLineToProjectToward ()
 Returns the line to project toward
Created in NX5.0.0. More...
 
bool NearestPointOption ()
 Returns the nearest point option whether to project curve by nearest point or not. More...
 
NXOpen::PlanePlaneToProjectTo ()
 Returns the plane to project to
Created in NX5.0.0. More...
 
NXOpen::PointPointToProjectToward ()
 Returns the point to project toward
Created in NX5.0.0. More...
 
NXOpen::Features::ProjectCurveBuilder::DirectionType ProjectionDirectionMethod ()
 Returns the projection direction method
Created in NX5.0.0. More...
 
NXOpen::Features::ProjectCurveBuilder::ProjectionOptionType ProjectionOption ()
 Returns the projection option type
Created in NX5.0.0. More...
 
NXOpen::DirectionProjectionVector ()
 Returns the projection vector
Created in NX5.0.0. More...
 
NXOpen::PointReferencePointForEqualArcLength ()
 Returns the reference point for equal arc length
Created in NX5.0.0. More...
 
NXOpen::SectionSectionToProject ()
 Returns the section to project
Created in NX5.0.0. More...
 
void SetBridgedGapSize (double bridgedGapSize)
 Sets the maximum bridged gap size. More...
 
void SetEqualArcLengthMethod (NXOpen::Features::ProjectCurveBuilder::ArcLengthType arcLengthMethod)
 Sets the equal arc length method
Created in NX5.0.0. More...
 
void SetGapOption (bool gapOption)
 Sets the gap option whether to create curve to bridge gap or not
Created in NX7.5.0. More...
 
void SetNearestPointOption (bool nearestPointOption)
 Sets the nearest point option whether to project curve by nearest point or not. More...
 
void SetPlaneToProjectTo (NXOpen::Plane *projectedPlane)
 Sets the plane to project to
Created in NX5.0.0. More...
 
void SetPointToProjectToward (NXOpen::Point *towardPoint)
 Sets the point to project toward
Created in NX5.0.0. More...
 
void SetProjectionDirectionMethod (NXOpen::Features::ProjectCurveBuilder::DirectionType directionMethod)
 Sets the projection direction method
Created in NX5.0.0. More...
 
void SetProjectionOption (NXOpen::Features::ProjectCurveBuilder::ProjectionOptionType projectionOption)
 Sets the projection option type
Created in NX5.0.0. More...
 
void SetProjectionVector (NXOpen::Direction *alongVector)
 Sets the projection vector
Created in NX5.0.0. More...
 
void SetReferencePointForEqualArcLength (NXOpen::Point *referencePoint)
 Sets the reference point for equal arc length
Created in NX5.0.0. More...
 
void SetTolerance (double tolerance)
 Sets the tolerance
Created in NX5.0.0. More...
 
void SetXVectorForEqualArcLength (NXOpen::Direction *xVector)
 Sets the x vector for equal arc length
Created in NX5.0.0. More...
 
double Tolerance ()
 Returns the tolerance
Created in NX5.0.0. More...
 
NXOpen::DirectionXVectorForEqualArcLength ()
 Returns the x vector for equal arc length
Created in NX5.0.0. More...
 
- Public Member Functions inherited from NXOpen::Features::FeatureBuilder
NXOpen::Features::FeatureCommitFeature ()
 Commits the feature parameters and creates the feature. More...
 
NXOpen::Features::FeatureGetFeature ()
 Returns the feature currently being edited by this builder. More...
 
void HideInternalParentFeatureAfterEdit (NXOpen::Features::Feature *parentFeature)
 Re-suppress an internal parent feature (a slave feature) after it has been edited. More...
 
bool ParentFeatureInternal ()
 Returns whether or not the latest timestamped parent feature of this feature should be made internal
Created in NX5.0.0. More...
 
bool PatchSolutionFlag ()
 Returns the patch solution flag
Created in NX8.0.1. More...
 
NXString PatchSurfaceFilename ()
 Returns the patch surface filename
Created in NX8.0.1. More...
 
void SetParentFeatureInternal (NXOpen::Features::Feature *parentFeature)
 Set the parent features which would be internal or slaves to the feature being created or commited
Created in NX6.0.0. More...
 
void SetParentFeatureInternal (bool isInternal)
 Sets whether or not the latest timestamped parent feature of this feature should be made internal
Created in NX5.0.0. More...
 
void SetPatchSolutionFlag (bool optionValue)
 Sets the patch solution flag
Created in NX8.0.1. More...
 
void SetPatchSurfaceFilename (const NXString &surfaceFilename)
 Sets the patch surface filename
Created in NX8.0.1. More...
 
void SetPatchSurfaceFilename (const char *surfaceFilename)
 Sets the patch surface filename
Created in NX8.0.1. More...
 
void SetSurroundingPatchSurfaceFilename (const NXString &surroundingSurfaceFilename)
 Sets the surrounding patch surface filename
Created in NX8.0.1. More...
 
void SetSurroundingPatchSurfaceFilename (const char *surroundingSurfaceFilename)
 Sets the surrounding patch surface filename
Created in NX8.0.1. More...
 
void ShowInternalParentFeatureForEdit (NXOpen::Features::Feature *parentFeature)
 Unsuppress an internal parent feature (a slave feature) so it can be edited. More...
 
NXString SurroundingPatchSurfaceFilename ()
 Returns the surrounding patch surface filename
Created in NX8.0.1. More...
 
void UnsetParentFeatureInternal (NXOpen::Features::Feature *parentFeature)
 Set the internal parent feature of the feature being edited to external
Created in NX6.0.0. More...
 
- Public Member Functions inherited from NXOpen::Builder
NXOpen::NXObjectCommit ()
 Commits any edits that have been applied to the builder. More...
 
void Destroy ()
 Deletes the builder, and cleans up any objects created by the builder. More...
 
std::vector< NXOpen::NXObject * > GetCommittedObjects ()
 For builders that create more than one object, this method returns the objects that are created by commit. More...
 
NXOpen::NXObjectGetObject ()
 Returns the object currently being edited by this builder. More...
 
void ShowResults ()
 Updates the model to reflect the result of an edit to the model for all builders that support showing results. More...
 
virtual bool Validate ()
 Validate whether the inputs to the component are sufficient for commit to be called. More...
 
- Public Member Functions inherited from NXOpen::TaggedObject
tag_t Tag () const
 Returns the tag of this object. More...
 

Detailed Description

Represents a NXOpen::Features::ProjectCurve builder.

Inputs to this class can be convergent objects.
To create a new instance of this class, use NXOpen::Features::FeatureCollection::CreateProjectCurveBuilder
Default values.

Property Value

AngleToProjectionVector.Value

0.0

BridgedGapSize

1.0 (millimeters part), 0.04 (inches part)

CurveFitData.CurveJoinMethod

No

CurveFitData.Degree

7

CurveFitData.FitMethod

DegreeAndSegments

CurveFitData.IsAdvancedFit

0

CurveFitData.IsAlignShape

0

CurveFitData.MaximumDegree

7

CurveFitData.MaximumSegments

1

CurveFitData.MinimumDegree

5

CurveFitData.Segments

1

CurveFitJoinData.CurveFitOptions.FitOption (deprecated)

Cubic

CurveFitJoinData.CurveFitOptions.MaximumDegree (deprecated)

7

CurveFitJoinData.CurveFitOptions.MaximumSegments (deprecated)

1

EqualArcLengthMethod

BothXY

GapOption

false

InputCurvesOption.Associative

True

NearestPointOption

false

ProjectionDirectionMethod

AlongFaceNormal

ProjectionOption

None


Created in NX5.0.0.

Member Enumeration Documentation

Represents Equal Arc Length type.

Enumerator
ArcLengthTypeBothXY 

Represents Both X and Y.

ArcLengthTypeFirstXThenY 

Represents First X then Y.

ArcLengthTypeFirstYThenX 

Represents First Y then X.

ArcLengthTypeXOnly 

Represents X only.

ArcLengthTypeYOnly 

Represents Y only.

Represents direction method.

Enumerator
DirectionTypeAlongFaceNormal 

Represents Along Face Normal.

DirectionTypeTowardPoint 

Represents Towards Point.

DirectionTypeTowardLine 

Represents Towards Line.

DirectionTypeAlongVector 

Represents Along Vector.

DirectionTypeAngleToVector 

Represents Angle To Vector.

Represents projection option type used when direction type is along vector.

Enumerator
ProjectionOptionTypeNone 

Represents None.

ProjectionOptionTypeProjectBothSides 

Represents Project Both Sides.

ProjectionOptionTypeEqualArcLength 

Represents Equal Arc Length.

Member Function Documentation

NXOpen::Expression* NXOpen::Features::ProjectCurveBuilder::AngleToProjectionVector ( )

Returns the angle to projection vector
Created in NX5.0.0.



License requirements : None

double NXOpen::Features::ProjectCurveBuilder::BridgedGapSize ( )

Returns the maximum bridged gap size.

When gap distance is less than maximum bridged gap size and bigger than the default modeling tolerance, NX project curve will add an internal bridge curve to close the gap between segments in projection curve. This option is only valid if NXOpen::Features::ProjectCurveBuilder::GapOption and NXOpen::Features::ProjectCurveBuilder::SetGapOption is true.


Created in NX7.5.0.

License requirements : None

NXOpen::GeometricUtilities::CurveFitData* NXOpen::Features::ProjectCurveBuilder::CurveFitData ( )

Returns the curve fit settings
Created in NX8.0.0.



License requirements : None

NXOpen::GeometricUtilities::CurveFitJoin* NXOpen::Features::ProjectCurveBuilder::CurveFitJoinData ( )

Returns the curve fit join method

Deprecated:
Deprecated in NX8.0.0.

Use NXOpen::Features::ProjectCurveBuilder::CurveFitData instead


Created in NX5.0.0.

License requirements : None

NXOpen::Features::ProjectCurveBuilder::ArcLengthType NXOpen::Features::ProjectCurveBuilder::EqualArcLengthMethod ( )

Returns the equal arc length method
Created in NX5.0.0.



License requirements : None

NXOpen::SelectObjectList* NXOpen::Features::ProjectCurveBuilder::FaceToProjectTo ( )

Returns the face to project to
Created in NX5.0.0.



License requirements : None

bool NXOpen::Features::ProjectCurveBuilder::GapOption ( )

Returns the gap option whether to create curve to bridge gap or not
Created in NX7.5.0.



License requirements : None

NXOpen::GeometricUtilities::CurveOptions* NXOpen::Features::ProjectCurveBuilder::InputCurvesOption ( )

Returns the input curves option
Created in NX5.0.0.



License requirements : None

NXOpen::SelectDisplayableObject* NXOpen::Features::ProjectCurveBuilder::LineToProjectToward ( )

Returns the line to project toward
Created in NX5.0.0.



License requirements : None

bool NXOpen::Features::ProjectCurveBuilder::NearestPointOption ( )

Returns the nearest point option whether to project curve by nearest point or not.

This option is only valid if NXOpen::Features::ProjectCurveBuilder::DirectionTypeAlongVector is used and NXOpen::Features::ProjectCurveBuilder::ProjectionOptionTypeNone or NXOpen::Features::ProjectCurveBuilder::ProjectionOptionTypeProjectBothSides is used.


Created in NX7.5.0.

License requirements : None

NXOpen::Plane* NXOpen::Features::ProjectCurveBuilder::PlaneToProjectTo ( )

Returns the plane to project to
Created in NX5.0.0.



License requirements : None

NXOpen::Point* NXOpen::Features::ProjectCurveBuilder::PointToProjectToward ( )

Returns the point to project toward
Created in NX5.0.0.



License requirements : None

NXOpen::Features::ProjectCurveBuilder::DirectionType NXOpen::Features::ProjectCurveBuilder::ProjectionDirectionMethod ( )

Returns the projection direction method
Created in NX5.0.0.



License requirements : None

NXOpen::Features::ProjectCurveBuilder::ProjectionOptionType NXOpen::Features::ProjectCurveBuilder::ProjectionOption ( )

Returns the projection option type
Created in NX5.0.0.



License requirements : None

NXOpen::Direction* NXOpen::Features::ProjectCurveBuilder::ProjectionVector ( )

Returns the projection vector
Created in NX5.0.0.



License requirements : None

NXOpen::Point* NXOpen::Features::ProjectCurveBuilder::ReferencePointForEqualArcLength ( )

Returns the reference point for equal arc length
Created in NX5.0.0.



License requirements : None

NXOpen::Section* NXOpen::Features::ProjectCurveBuilder::SectionToProject ( )

Returns the section to project
Created in NX5.0.0.



License requirements : None

void NXOpen::Features::ProjectCurveBuilder::SetBridgedGapSize ( double  bridgedGapSize)

Sets the maximum bridged gap size.

When gap distance is less than maximum bridged gap size and bigger than the default modeling tolerance, NX project curve will add an internal bridge curve to close the gap between segments in projection curve. This option is only valid if NXOpen::Features::ProjectCurveBuilder::GapOption and NXOpen::Features::ProjectCurveBuilder::SetGapOption is true.


Created in NX7.5.0.

License requirements : solid_modeling ("SOLIDS MODELING") OR cam_base ("CAM BASE") OR insp_programming ("INSPECTION PROGRAMMING")

Parameters
bridgedGapSizebridgedgapsize
void NXOpen::Features::ProjectCurveBuilder::SetEqualArcLengthMethod ( NXOpen::Features::ProjectCurveBuilder::ArcLengthType  arcLengthMethod)

Sets the equal arc length method
Created in NX5.0.0.



License requirements : solid_modeling ("SOLIDS MODELING") OR cam_base ("CAM BASE") OR insp_programming ("INSPECTION PROGRAMMING")

Parameters
arcLengthMethodarclengthmethod
void NXOpen::Features::ProjectCurveBuilder::SetGapOption ( bool  gapOption)

Sets the gap option whether to create curve to bridge gap or not
Created in NX7.5.0.



License requirements : solid_modeling ("SOLIDS MODELING") OR cam_base ("CAM BASE") OR insp_programming ("INSPECTION PROGRAMMING")

Parameters
gapOptiongapoption
void NXOpen::Features::ProjectCurveBuilder::SetNearestPointOption ( bool  nearestPointOption)

Sets the nearest point option whether to project curve by nearest point or not.

This option is only valid if NXOpen::Features::ProjectCurveBuilder::DirectionTypeAlongVector is used and NXOpen::Features::ProjectCurveBuilder::ProjectionOptionTypeNone or NXOpen::Features::ProjectCurveBuilder::ProjectionOptionTypeProjectBothSides is used.


Created in NX7.5.0.

License requirements : solid_modeling ("SOLIDS MODELING") OR cam_base ("CAM BASE") OR insp_programming ("INSPECTION PROGRAMMING")

Parameters
nearestPointOptionnearestpointoption
void NXOpen::Features::ProjectCurveBuilder::SetPlaneToProjectTo ( NXOpen::Plane projectedPlane)

Sets the plane to project to
Created in NX5.0.0.



License requirements : solid_modeling ("SOLIDS MODELING") OR cam_base ("CAM BASE") OR insp_programming ("INSPECTION PROGRAMMING")

Parameters
projectedPlaneprojectedplane
void NXOpen::Features::ProjectCurveBuilder::SetPointToProjectToward ( NXOpen::Point towardPoint)

Sets the point to project toward
Created in NX5.0.0.



License requirements : solid_modeling ("SOLIDS MODELING") OR cam_base ("CAM BASE") OR insp_programming ("INSPECTION PROGRAMMING")

Parameters
towardPointtowardpoint
void NXOpen::Features::ProjectCurveBuilder::SetProjectionDirectionMethod ( NXOpen::Features::ProjectCurveBuilder::DirectionType  directionMethod)

Sets the projection direction method
Created in NX5.0.0.



License requirements : solid_modeling ("SOLIDS MODELING") OR cam_base ("CAM BASE") OR insp_programming ("INSPECTION PROGRAMMING")

Parameters
directionMethoddirectionmethod
void NXOpen::Features::ProjectCurveBuilder::SetProjectionOption ( NXOpen::Features::ProjectCurveBuilder::ProjectionOptionType  projectionOption)

Sets the projection option type
Created in NX5.0.0.



License requirements : solid_modeling ("SOLIDS MODELING") OR cam_base ("CAM BASE") OR insp_programming ("INSPECTION PROGRAMMING")

Parameters
projectionOptionprojectionoption
void NXOpen::Features::ProjectCurveBuilder::SetProjectionVector ( NXOpen::Direction alongVector)

Sets the projection vector
Created in NX5.0.0.



License requirements : solid_modeling ("SOLIDS MODELING") OR cam_base ("CAM BASE") OR insp_programming ("INSPECTION PROGRAMMING")

Parameters
alongVectoralongvector
void NXOpen::Features::ProjectCurveBuilder::SetReferencePointForEqualArcLength ( NXOpen::Point referencePoint)

Sets the reference point for equal arc length
Created in NX5.0.0.



License requirements : solid_modeling ("SOLIDS MODELING") OR cam_base ("CAM BASE") OR insp_programming ("INSPECTION PROGRAMMING")

Parameters
referencePointreferencepoint
void NXOpen::Features::ProjectCurveBuilder::SetTolerance ( double  tolerance)

Sets the tolerance
Created in NX5.0.0.



License requirements : solid_modeling ("SOLIDS MODELING") OR cam_base ("CAM BASE") OR insp_programming ("INSPECTION PROGRAMMING")

Parameters
tolerancetolerance
void NXOpen::Features::ProjectCurveBuilder::SetXVectorForEqualArcLength ( NXOpen::Direction xVector)

Sets the x vector for equal arc length
Created in NX5.0.0.



License requirements : solid_modeling ("SOLIDS MODELING") OR cam_base ("CAM BASE") OR insp_programming ("INSPECTION PROGRAMMING")

Parameters
xVectorxvector
double NXOpen::Features::ProjectCurveBuilder::Tolerance ( )

Returns the tolerance
Created in NX5.0.0.



License requirements : None

NXOpen::Direction* NXOpen::Features::ProjectCurveBuilder::XVectorForEqualArcLength ( )

Returns the x vector for equal arc length
Created in NX5.0.0.



License requirements : None


The documentation for this class was generated from the following file:
Copyright 2017 Siemens Product Lifecycle Management Software Inc. All Rights Reserved.